Index: uspace/lib/net/tl/socket_core.c
===================================================================
--- uspace/lib/net/tl/socket_core.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/net/tl/socket_core.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -91,11 +91,11 @@
 	int packet_id;
 
-	/* If bound */
+	// if bound
 	if (socket->port) {
-		/* Release the port */
+		// release the port
 		socket_port_release(global_sockets, socket);
 	}
 	
-	/* Release all received packets */
+	// release all received packets
 	while ((packet_id = dyn_fifo_pop(&socket->received)) >= 0)
 		pq_release_remote(packet_phone, packet_id);
@@ -166,5 +166,5 @@
 	int rc;
 
-	/* Create a wrapper */
+	// create a wrapper
 	socket_ref = malloc(sizeof(*socket_ref));
 	if (!socket_ref)
@@ -172,5 +172,5 @@
 
 	*socket_ref = socket;
-	/* Add the wrapper */
+	// add the wrapper
 	rc = socket_port_map_add(&socket_port->map, key, key_length,
 	    socket_ref);
@@ -206,5 +206,5 @@
 	int rc;
 
-	/* Create a wrapper */
+	// create a wrapper
 	socket_port = malloc(sizeof(*socket_port));
 	if (!socket_port)
@@ -221,5 +221,5 @@
 		goto fail;
 	
-	/* Register the incoming port */
+	// register the incomming port
 	rc = socket_ports_add(global_sockets, port, socket_port);
 	if (rc < 0)
@@ -277,25 +277,25 @@
 		
 		address_in = (struct sockaddr_in *) addr;
-		/* Find the socket */
+		// find the socket
 		socket = socket_cores_find(local_sockets, socket_id);
 		if (!socket)
 			return ENOTSOCK;
 		
-		/* Bind a free port? */
+		// bind a free port?
 		if (address_in->sin_port <= 0)
 			return socket_bind_free_port(global_sockets, socket,
 			     free_ports_start, free_ports_end, last_used_port);
 		
-		/* Try to find the port */
+		// try to find the port
 		socket_port = socket_ports_find(global_sockets,
 		    ntohs(address_in->sin_port));
 		if (socket_port) {
-			/* Already used */
+			// already used
 			return EADDRINUSE;
 		}
 		
-		/* If bound */
+		// if bound
 		if (socket->port) {
-			/* Release the port */
+			// release the port
 			socket_port_release(global_sockets, socket);
 		}
@@ -333,5 +333,5 @@
 	int index;
 
-	/* From the last used one */
+	// from the last used one
 	index = last_used_port;
 	
@@ -339,18 +339,18 @@
 		++index;
 		
-		/* Till the range end */
+		// til the range end
 		if (index >= free_ports_end) {
-			/* Start from the range beginning */
+			// start from the range beginning
 			index = free_ports_start - 1;
 			do {
 				++index;
-				/* Till the last used one */
+				// til the last used one
 				if (index >= last_used_port) {
-					/* None found */
+					// none found
 					return ENOTCONN;
 				}
 			} while (socket_ports_find(global_sockets, index));
 			
-			/* Found, break immediately */
+			// found, break immediately
 			break;
 		}
@@ -376,7 +376,5 @@
 
 	count = 0;
-#if 0
-	socket_id = socket_globals.last_id;
-#endif
+//	socket_id = socket_globals.last_id;
 	do {
 		if (count < SOCKET_ID_TRIES) {
@@ -386,14 +384,12 @@
 			socket_id = 1;
 			++count;
-		/* Only this branch for last_id */
+		// only this branch for last_id
 		} else {
 			if (socket_id < INT_MAX) {
 				++ socket_id;
-#if 0
-			} else if(socket_globals.last_id) {
-				socket_globals.last_id = 0;
-				socket_id = 1;
-#endif
-			} else {
+/*			} else if(socket_globals.last_id) {
+*				socket_globals.last_id = 0;
+*				socket_id = 1;
+*/			} else {
 				return ELIMIT;
 			}
@@ -429,5 +425,5 @@
 		return EINVAL;
 	
-	/* Store the socket */
+	// store the socket
 	if (*socket_id <= 0) {
 		positive = (*socket_id == 0);
@@ -445,5 +441,5 @@
 		return ENOMEM;
 	
-	/* Initialize */
+	// initialize
 	socket->phone = app_phone;
 	socket->port = -1;
@@ -497,10 +493,10 @@
 	int accepted_id;
 
-	/* Find the socket */
+	// find the socket
 	socket = socket_cores_find(local_sockets, socket_id);
 	if (!socket)
 		return ENOTSOCK;
 	
-	/* Destroy all accepted sockets */
+	// destroy all accepted sockets
 	while ((accepted_id = dyn_fifo_pop(&socket->accepted)) >= 0)
 		socket_destroy(packet_phone, accepted_id, local_sockets,
@@ -539,13 +535,13 @@
 	next_packet = pq_next(packet);
 	if (!next_packet) {
-		/* Write all if only one fragment */
+		// write all if only one fragment
 		rc = data_reply(packet_get_data(packet),
 		    packet_get_data_length(packet));
 		if (rc != EOK)
 			return rc;
-		/* Store the total length */
+		// store the total length
 		*length = packet_get_data_length(packet);
 	} else {
-		/* Count the packet fragments */
+		// count the packet fragments
 		fragments = 1;
 		next_packet = pq_next(packet);
@@ -553,5 +549,5 @@
 			++fragments;
 		
-		/* Compute and store the fragment lengths */
+		// compute and store the fragment lengths
 		lengths = (size_t *) malloc(sizeof(size_t) * fragments +
 		    sizeof(size_t));
@@ -569,5 +565,5 @@
 		}
 		
-		/* Write the fragment lengths */
+		// write the fragment lengths
 		rc = data_reply(lengths, sizeof(int) * (fragments + 1));
 		if (rc != EOK) {
@@ -577,5 +573,5 @@
 		next_packet = packet;
 		
-		/* Write the fragments */
+		// write the fragments
 		for (index = 0; index < fragments; ++index) {
 			rc = data_reply(packet_get_data(next_packet),
@@ -588,5 +584,5 @@
 		}
 		
-		/* Store the total length */
+		// store the total length
 		*length = lengths[fragments];
 		free(lengths);
@@ -640,8 +636,8 @@
 		return;
 	
-	/* Find ports */
+	// find ports
 	socket_port = socket_ports_find(global_sockets, socket->port);
 	if (socket_port) {
-		/* Find the socket */
+		// find the socket
 		socket_ref = socket_port_map_find(&socket_port->map,
 		    socket->key, socket->key_length);
@@ -650,13 +646,13 @@
 			--socket_port->count;
 			
-			/* Release if empty */
+			// release if empty
 			if (socket_port->count <= 0) {
-				/* Destroy the map */
+				// destroy the map
 				socket_port_map_destroy(&socket_port->map, free);
-				/* Release the port */
+				// release the port
 				socket_ports_exclude(global_sockets,
 				    socket->port, free);
 			} else {
-				/* Remove */
+				// remove
 				socket_port_map_exclude(&socket_port->map,
 				    socket->key, socket->key_length, free);
@@ -689,10 +685,10 @@
 	int rc;
 
-	/* Find ports */
+	// find ports
 	socket_port = socket_ports_find(global_sockets, port);
 	if (!socket_port)
 		return ENOENT;
 	
-	/* Add the socket */
+	// add the socket
 	rc = socket_port_add_core(socket_port, socket, key, key_length);
 	if (rc != EOK)
Index: uspace/lib/net/tl/tl_common.c
===================================================================
--- uspace/lib/net/tl/tl_common.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/net/tl/tl_common.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -255,5 +255,5 @@
 	int length;
 
-	/* Detach the first packet and release the others */
+	// detach the first packet and release the others
 	next = pq_detach(packet);
 	if (next)
@@ -262,8 +262,6 @@
 	length = packet_get_addr(packet, &src, NULL);
 	if ((length > 0) && (!error) && (icmp_phone >= 0) &&
-	    /*
-	     * Set both addresses to the source one (avoids the source address
-	     * deletion before setting the destination one)
-	     */
+	    // set both addresses to the source one (avoids the source address
+	    // deletion before setting the destination one)
 	    (packet_set_addr(packet, src, src, (size_t) length) == EOK)) {
 		return EOK;
@@ -301,9 +299,9 @@
 		return EINVAL;
 
-	/* Get the data length */
+	// get the data length
 	if (!async_data_write_receive(&callid, &length))
 		return EINVAL;
 
-	/* Get a new packet */
+	// get a new packet
 	*packet = packet_get_4_remote(packet_phone, length, dimension->addr_len,
 	    prefix + dimension->prefix, dimension->suffix);
@@ -311,5 +309,5 @@
 		return ENOMEM;
 
-	/* Allocate space in the packet */
+	// allocate space in the packet
 	data = packet_suffix(*packet, length);
 	if (!data) {
@@ -318,5 +316,5 @@
 	}
 
-	/* Read the data into the packet */
+	// read the data into the packet
 	rc = async_data_write_finalize(callid, data, length);
 	if (rc != EOK) {
@@ -325,5 +323,5 @@
 	}
 	
-	/* Set the packet destination address */
+	// set the packet destination address
 	rc = packet_set_addr(*packet, NULL, (uint8_t *) addr, addrlen);
 	if (rc != EOK) {
Index: uspace/lib/packet/generic/packet_server.c
===================================================================
--- uspace/lib/packet/generic/packet_server.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/packet/generic/packet_server.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -112,9 +112,9 @@
     size_t max_content, size_t max_suffix)
 {
-	/* Clear the packet content */
+	// clear the packet content
 	bzero(((void *) packet) + sizeof(packet_t),
 	    packet->length - sizeof(packet_t));
 	
-	/* Clear the packet header */
+	// clear the packet header
 	packet->order = 0;
 	packet->metric = 0;
@@ -151,5 +151,5 @@
 	assert(fibril_mutex_is_locked(&ps_globals.lock));
 
-	/* Already locked */
+	// already locked
 	packet = (packet_t *) mmap(NULL, length, PROTO_READ | PROTO_WRITE,
 	    MAP_SHARED | MAP_ANONYMOUS, 0, 0);
Index: uspace/lib/softint/generic/multiplication.c
===================================================================
--- uspace/lib/softint/generic/multiplication.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/softint/generic/multiplication.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -109,5 +109,5 @@
 	 * result does not fit in signed one */
 	if (SOFTINT_CHECK_OF && ((t2 < t1) || (t2 & (1ull << 63)))) {
-		/* Error, overflow */
+		// error, overflow
 		return (neg ? INT64_MIN : INT64_MAX);
 	}
Index: uspace/lib/usb/Makefile
===================================================================
--- uspace/lib/usb/Makefile	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/Makefile	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -34,5 +34,4 @@
 SOURCES = \
 	src/addrkeep.c \
-	src/altiface.c \
 	src/class.c \
 	src/ddfiface.c \
@@ -42,8 +41,6 @@
 	src/dp.c \
 	src/dump.c \
-	src/hidiface.c \
 	src/hidparser.c \
 	src/hub.c \
-	src/pipepriv.c \
 	src/pipes.c \
 	src/pipesinit.c \
Index: uspace/lib/usb/include/usb/classes/hidparser.h
===================================================================
--- uspace/lib/usb/include/usb/classes/hidparser.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/classes/hidparser.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -317,5 +317,4 @@
 usb_hid_report_path_t *usb_hid_report_path_clone(usb_hid_report_path_t *usage_path);
 
-usb_hid_report_field_t *usb_hid_report_get_sibling(usb_hid_report_t *report, usb_hid_report_field_t *field, usb_hid_report_path_t *path, int flags, usb_hid_report_type_t type);
 
 /*
Index: uspace/lib/usb/include/usb/classes/hub.h
===================================================================
--- uspace/lib/usb/include/usb/classes/hub.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/classes/hub.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -43,6 +43,4 @@
  */
 typedef enum {
-	USB_HUB_FEATURE_HUB_LOCAL_POWER = 0,
-	USB_HUB_FEATURE_HUB_OVER_CURRENT = 1,
 	USB_HUB_FEATURE_C_HUB_LOCAL_POWER = 0,
 	USB_HUB_FEATURE_C_HUB_OVER_CURRENT = 1,
@@ -61,5 +59,4 @@
 	/* USB_HUB_FEATURE_ = , */
 } usb_hub_class_feature_t;
-
 
 /** Header of standard hub descriptor without the "variadic" part. */
@@ -152,5 +149,5 @@
             maximum of 255 ports).
      */
-    uint8_t devices_removable[32];
+    uint8_t * devices_removable;
 
     /**
Index: uspace/lib/usb/include/usb/devdrv.h
===================================================================
--- uspace/lib/usb/include/usb/devdrv.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/devdrv.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -162,14 +162,10 @@
     usb_endpoint_description_t **);
 
-int usb_device_retrieve_descriptors(usb_pipe_t *, usb_device_descriptors_t *);
-int usb_device_create_pipes(ddf_dev_t *, usb_device_connection_t *,
-    usb_endpoint_description_t **, uint8_t *, size_t, int, int,
-    usb_endpoint_mapping_t **, size_t *);
-int usb_device_destroy_pipes(ddf_dev_t *, usb_endpoint_mapping_t *, size_t);
-int usb_device_create(ddf_dev_t *, usb_endpoint_description_t **, usb_device_t **, const char **);
+typedef bool (*usb_polling_callback_t)(usb_device_t *,
+    uint8_t *, size_t, void *);
+typedef void (*usb_polling_terminted_callback_t)(usb_device_t *, bool, void *);
 
-size_t usb_interface_count_alternates(uint8_t *, size_t, uint8_t);
-int usb_alternate_interfaces_create(uint8_t *, size_t, int,
-    usb_alternate_interfaces_t **);
+int usb_device_auto_poll(usb_device_t *, size_t,
+    usb_polling_callback_t, size_t, usb_polling_terminted_callback_t, void *);
 
 #endif
Index: uspace/lib/usb/include/usb/host/batch.h
===================================================================
--- uspace/lib/usb/include/usb/host/batch.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/host/batch.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -43,27 +43,34 @@
 typedef struct usb_transfer_batch usb_transfer_batch_t;
 struct usb_transfer_batch {
-	endpoint_t *ep;
 	link_t link;
+	usb_target_t target;
+	usb_transfer_type_t transfer_type;
+	usb_speed_t speed;
+	usb_direction_t direction;
 	usbhc_iface_transfer_in_callback_t callback_in;
 	usbhc_iface_transfer_out_callback_t callback_out;
-	void *arg;
 	char *buffer;
-	char *data_buffer;
+	char *transport_buffer;
 	size_t buffer_size;
 	char *setup_buffer;
 	size_t setup_size;
+	size_t max_packet_size;
 	size_t transfered_size;
 	void (*next_step)(usb_transfer_batch_t *);
 	int error;
 	ddf_fun_t *fun;
+	void *arg;
+	endpoint_t *ep;
 	void *private_data;
-	void (*private_data_dtor)(void *p_data);
 };
 
 void usb_transfer_batch_init(
     usb_transfer_batch_t *instance,
-    endpoint_t *ep,
+    usb_target_t target,
+    usb_transfer_type_t transfer_type,
+    usb_speed_t speed,
+    size_t max_packet_size,
     char *buffer,
-    char *data_buffer,
+    char *transport_buffer,
     size_t buffer_size,
     char *setup_buffer,
@@ -73,20 +80,7 @@
     void *arg,
     ddf_fun_t *fun,
-    void *private_data,
-    void (*private_data_dtor)(void *p_data)
+		endpoint_t *ep,
+    void *private_data
 );
-
-void usb_transfer_batch_call_in_and_dispose(usb_transfer_batch_t *instance);
-void usb_transfer_batch_call_out_and_dispose(usb_transfer_batch_t *instance);
-void usb_transfer_batch_finish(usb_transfer_batch_t *instance);
-void usb_transfer_batch_dispose(usb_transfer_batch_t *instance);
-
-static inline void usb_transfer_batch_finish_error(
-    usb_transfer_batch_t *instance, int error)
-{
-	assert(instance);
-	instance->error = error;
-	usb_transfer_batch_finish(instance);
-}
 
 static inline usb_transfer_batch_t *usb_transfer_batch_from_link(link_t *l)
@@ -96,4 +90,8 @@
 }
 
+void usb_transfer_batch_call_in(usb_transfer_batch_t *instance);
+void usb_transfer_batch_call_out(usb_transfer_batch_t *instance);
+void usb_transfer_batch_finish(usb_transfer_batch_t *instance, int error);
+
 #endif
 /**
Index: uspace/lib/usb/include/usb/host/device_keeper.h
===================================================================
--- uspace/lib/usb/include/usb/host/device_keeper.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/host/device_keeper.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -54,4 +54,6 @@
 	usb_speed_t speed;
 	bool occupied;
+	link_t endpoints;
+	uint16_t control_used;
 	devman_handle_t handle;
 };
@@ -63,8 +65,20 @@
 	struct usb_device_info devices[USB_ADDRESS_COUNT];
 	fibril_mutex_t guard;
+	fibril_condvar_t change;
 	usb_address_t last_address;
 } usb_device_keeper_t;
 
 void usb_device_keeper_init(usb_device_keeper_t *instance);
+
+void usb_device_keeper_add_ep(
+    usb_device_keeper_t *instance, usb_address_t address, endpoint_t *ep);
+
+void usb_device_keeper_reserve_default_address(
+    usb_device_keeper_t *instance, usb_speed_t speed);
+
+void usb_device_keeper_release_default_address(usb_device_keeper_t *instance);
+
+void usb_device_keeper_reset_if_need(usb_device_keeper_t *instance,
+    usb_target_t target, const uint8_t *setup_data);
 
 usb_address_t device_keeper_get_free_address(usb_device_keeper_t *instance,
@@ -82,4 +96,11 @@
 usb_speed_t usb_device_keeper_get_speed(usb_device_keeper_t *instance,
     usb_address_t address);
+
+void usb_device_keeper_use_control(usb_device_keeper_t *instance,
+    usb_target_t target);
+
+void usb_device_keeper_release_control(usb_device_keeper_t *instance,
+    usb_target_t target);
+
 #endif
 /**
Index: uspace/lib/usb/include/usb/host/endpoint.h
===================================================================
--- uspace/lib/usb/include/usb/host/endpoint.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/host/endpoint.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -39,6 +39,4 @@
 #include <bool.h>
 #include <adt/list.h>
-#include <fibril_synch.h>
-
 #include <usb/usb.h>
 
@@ -50,13 +48,7 @@
 	usb_speed_t speed;
 	size_t max_packet_size;
+	bool active;
 	unsigned toggle:1;
-	fibril_mutex_t guard;
-	fibril_condvar_t avail;
-	volatile bool active;
-	struct {
-		void *data;
-		int (*toggle_get)(void *);
-		void (*toggle_set)(void *, int);
-	} hc_data;
+	link_t same_device_eps;
 } endpoint_t;
 
@@ -67,18 +59,12 @@
 void endpoint_destroy(endpoint_t *instance);
 
-void endpoint_set_hc_data(endpoint_t *instance,
-    void *data, int (*toggle_get)(void *), void (*toggle_set)(void *, int));
-
-void endpoint_clear_hc_data(endpoint_t *instance);
-
-void endpoint_use(endpoint_t *instance);
-
-void endpoint_release(endpoint_t *instance);
-
 int endpoint_toggle_get(endpoint_t *instance);
 
 void endpoint_toggle_set(endpoint_t *instance, int toggle);
 
-void endpoint_toggle_reset_filtered(endpoint_t *instance, usb_target_t target);
+void endpoint_toggle_reset(link_t *ep);
+
+void endpoint_toggle_reset_filtered(link_t *ep, usb_endpoint_t epn);
+
 #endif
 /**
Index: uspace/lib/usb/include/usb/host/usb_endpoint_manager.h
===================================================================
--- uspace/lib/usb/include/usb/host/usb_endpoint_manager.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/host/usb_endpoint_manager.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -66,4 +66,9 @@
     endpoint_t *ep, size_t data_size);
 
+int usb_endpoint_manager_register_ep_wait(usb_endpoint_manager_t *instance,
+    usb_address_t address, usb_endpoint_t ep, usb_direction_t direction,
+    void *data, void (*data_remove_callback)(void* data, void* arg), void *arg,
+    size_t bw);
+
 int usb_endpoint_manager_unregister_ep(usb_endpoint_manager_t *instance,
     usb_address_t address, usb_endpoint_t ep, usb_direction_t direction);
@@ -73,30 +78,4 @@
     size_t *bw);
 
-void usb_endpoint_manager_reset_if_need(
-    usb_endpoint_manager_t *instance, usb_target_t target, const uint8_t *data);
-
-static inline int usb_endpoint_manager_add_ep(usb_endpoint_manager_t *instance,
-    usb_address_t address, usb_endpoint_t endpoint, usb_direction_t direction,
-    usb_transfer_type_t type, usb_speed_t speed, size_t max_packet_size,
-    size_t data_size)
-{
-	endpoint_t *ep = malloc(sizeof(endpoint_t));
-	if (ep == NULL)
-		return ENOMEM;
-
-	int ret = endpoint_init(ep, address, endpoint, direction, type, speed,
-	    max_packet_size);
-	if (ret != EOK) {
-		free(ep);
-		return ret;
-	}
-
-	ret = usb_endpoint_manager_register_ep(instance, ep, data_size);
-	if (ret != EOK) {
-		endpoint_destroy(ep);
-		return ret;
-	}
-	return EOK;
-}
 #endif
 /**
Index: uspace/lib/usb/include/usb/hub.h
===================================================================
--- uspace/lib/usb/include/usb/hub.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/hub.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -59,4 +59,7 @@
 } usb_hc_attached_device_t;
 
+int usb_hc_reserve_default_address(usb_hc_connection_t *, usb_speed_t);
+int usb_hc_release_default_address(usb_hc_connection_t *);
+
 usb_address_t usb_hc_request_address(usb_hc_connection_t *, usb_speed_t);
 int usb_hc_register_device(usb_hc_connection_t *,
Index: uspace/lib/usb/include/usb/pipes.h
===================================================================
--- uspace/lib/usb/include/usb/pipes.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/pipes.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -42,5 +42,4 @@
 #include <ipc/devman.h>
 #include <ddf/driver.h>
-#include <fibril_synch.h>
 
 /** Abstraction of a physical connection to the device.
@@ -60,14 +59,6 @@
  * This endpoint must be bound with existing usb_device_connection_t
  * (i.e. the wire to send data over).
- *
- * Locking order: if you want to lock both mutexes
- * (@c guard and @c hc_phone_mutex), lock @c guard first.
- * It is not necessary to lock @c guard if you want to lock @c hc_phone_mutex
- * only.
  */
 typedef struct {
-	/** Guard of the whole pipe. */
-	fibril_mutex_t guard;
-
 	/** The connection used for sending the data. */
 	usb_device_connection_t *wire;
@@ -87,21 +78,6 @@
 	/** Phone to the host controller.
 	 * Negative when no session is active.
-	 * It is an error to access this member without @c hc_phone_mutex
-	 * being locked.
-	 * If call over the phone is to be made, it must be preceeded by
-	 * call to pipe_add_ref() [internal libusb function].
 	 */
 	int hc_phone;
-
-	/** Guard for serialization of requests over the phone. */
-	fibril_mutex_t hc_phone_mutex;
-
-	/** Number of active transfers over the pipe. */
-	int refcount;
-
-	/** Whether to automatically reset halt on the endpoint.
-	 * Valid only for control endpoint zero.
-	 */
-	bool auto_reset_halt;
 } usb_pipe_t;
 
@@ -158,6 +134,4 @@
 int usb_pipe_initialize_from_configuration(usb_endpoint_mapping_t *,
     size_t, uint8_t *, size_t, usb_device_connection_t *);
-int usb_pipe_register_with_speed(usb_pipe_t *, usb_speed_t,
-    unsigned int, usb_hc_connection_t *);
 int usb_pipe_register(usb_pipe_t *, unsigned int, usb_hc_connection_t *);
 int usb_pipe_unregister(usb_pipe_t *, usb_hc_connection_t *);
@@ -166,7 +140,4 @@
 int usb_pipe_end_session(usb_pipe_t *);
 bool usb_pipe_is_session_started(usb_pipe_t *);
-
-int usb_pipe_start_long_transfer(usb_pipe_t *);
-void usb_pipe_end_long_transfer(usb_pipe_t *);
 
 int usb_pipe_read(usb_pipe_t *, void *, size_t, size_t *);
Index: uspace/lib/usb/include/usb/request.h
===================================================================
--- uspace/lib/usb/include/usb/request.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/request.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -50,10 +50,4 @@
 /** USB endpoint status - endpoint is halted (stalled). */
 #define USB_ENDPOINT_STATUS_HALTED ((uint16_t)(1 << 0))
-
-/** USB feature selector - endpoint halt (stall). */
-#define USB_FEATURE_SELECTOR_ENDPOINT_HALT (0)
-
-/** USB feature selector - device remote wake-up. */
-#define USB_FEATURE_SELECTOR_REMOTE_WAKEUP (1)
 
 /** Standard device request. */
@@ -141,6 +135,4 @@
     char **);
 
-int usb_request_clear_endpoint_halt(usb_pipe_t *, uint16_t);
-
 #endif
 /**
Index: uspace/lib/usb/include/usb/usb.h
===================================================================
--- uspace/lib/usb/include/usb/usb.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/lib/usb/include/usb/usb.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -77,7 +77,5 @@
 	USB_SPEED_FULL,
 	/** USB 2.0 high speed (480Mbits/s). */
-	USB_SPEED_HIGH,
-	/** Psuedo-speed serving as a boundary. */
-	USB_SPEED_MAX
+	USB_SPEED_HIGH
 } usb_speed_t;
 
